image: docker:19.03.8

services:
  - docker:19.03.8-dind

variables:
  SCAN_KUBERNETES_MANIFESTS: "true"
  DAST_WEBSITE: http://35.225.55.243/notes
  FUZZAPI_PROFILE: Long-100
  FUZZAPI_OPENAPI: test_openapi.v2.0.json
  FUZZAPI_TARGET_URL: http://35.225.55.243
  FUZZAPI_VERBOSE: "1"

stages:
  - build
  - test
  - c-fuzz
  - deploy
  - staging
  - fuzz
  - dast

include:
  - template: SAST.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: License-Scanning.gitlab-ci.yml
  - template: Container-Scanning.gitlab-ci.yml
  - template: DAST.gitlab-ci.yml
  - template: Secret-Detection.gitlab-ci.yml
  - template: Coverage-Fuzzing.gitlab-ci.yml
  - template: API-Fuzzing.gitlab-ci.yml
  - template: Managed-Cluster-Applications.gitlab-ci.yml

build:
  image: docker:19.03.8
  stage: build
  variables:
    IMAGE: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA
  script:
    - sleep 5
    - docker info
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE .
    - docker push $IMAGE

my_fuzz_target:
  image: python:3.9.1-buster
  stage: c-fuzz
  extends: .fuzz_base
  script:
    - pip install --extra-index-url https://gitlab.com/api/v4/projects/19904939/packages/pypi/simple pythonfuzz
    - ./gitlab-cov-fuzz run --engine pythonfuzz -- fuzz.py

deploy_staging:
  image: registry.gitlab.com/gitlab-org/cluster-integration/helm-install-image/releases/3.2.4-kube-1.13.12
  stage: staging
  variables:
    IMAGE: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA
    HELM_HOST: "localhost:44134"
  script:
    - export KUBE_INGRESS_BASE_DOMAIN=$(kubectl get svc --all-namespaces -o jsonpath='{range.items[?(@.status.loadBalancer.ingress)]}{.status.loadBalancer.ingress[*].ip}')
    - printenv
    - helm version
    - helm upgrade -f helm/values.yaml --set image=$IMAGE --install notes ./helm
  environment:
    name: staging
  allow_failure: true
